/*
 * cmdline.c: read the command line passed to us by the bootloader.
 *
 * Copyright (C) Harald Koerfgen
 *
 * $Id: cmdline.c,v 1.1 1999/09/14 01:26:21 sjhill Exp $
 */
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/config.h>
#include <linux/string.h>

#include <asm/bootinfo.h>

#undef PROM_DEBUG

#ifdef PROM_DEBUG
extern int prom_printf(char *);
#endif

char arcs_cmdline[CL_SIZE];

__initfunc(void prom_init_cmdline(int argc, char **argv))
{
	int i;

	/*
	 * collect args and prepare cmd_line
	 */
	for (i = 1; i < argc; i++) {
		strcat(arcs_cmdline, argv[i]);
		if (i < (argc - 1))
			strcat(arcs_cmdline, " ");
	}

#ifdef PROM_DEBUG
	prom_printf("arcs_cmdline: %s\n", &(arcs_cmdline[0]));
#endif

}

